/*
 * Mimas conversion tools
 *
 * Copyright (C) 2010-2012 Benjamin Moody
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

typedef struct _symbol {
  char *name;			/* Name of symbol on calculator */
  char *realname;		/* Original name */
  int id;			/* Symbol number */
} symbol;

/* Case mode */
enum {
  CASE_SIGNIFICANT,
  CASE_PRESERVED,
  CASE_FOLD_ALL
};

typedef struct _symbol_tab symbol_tab;

symbol_tab *symbol_tab_new(int case_mode);
void symbol_tab_free(symbol_tab *tab);
symbol *symbol_tab_add_symbol(symbol_tab *tab, const char *name);
unsigned int symbol_tab_count(symbol_tab *tab);
void symbol_tab_foreach(symbol_tab *tab,
			void (*func)(symbol *sym, void *data),
			void *data);
